﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    public class LexWatchBehaviour : MonoBehaviour, Messages.IOnGripped, Messages.IOnDrop, Messages.IUse
    {
        public static GameObject Mech;
        private UseEventTrigger Event;
        private FixedJoint2D Joint;
        private bool MechOut;

        public void OnGripped(GripBehaviour Hand)
        {
            foreach (FixedJoint2D joint in Hand.gameObject.GetComponents<FixedJoint2D>())
            {
                if (joint.connectedBody == this.gameObject.GetComponent<Rigidbody2D>())
                {
                    this.Joint = joint;
                    return;
                }
            }
            this.transform.rotation = Hand.transform.rotation;
            this.transform.position = Hand.transform.position - Hand.transform.TransformPoint(new Vector2(0f, 0.1f));
            this.Joint.anchor = new Vector2(0f, -0.3f);
            this.Joint.connectedAnchor = this.transform.InverseTransformPoint(Hand.transform.position - Hand.transform.TransformPoint(new Vector2(0f, 0.3f)));
        }

        public void OnDrop(GripBehaviour Hand)
        {
            GameObject.Destroy(this.Event);
        }

        public void Use(ActivationPropagation Prog)
        {
            if (!this.MechOut)
            {
                ModAPI.Notify("Calling Bobert MK1...");
                this.StartCoroutine(MechSpawn());
            }
        }

        private IEnumerator MechSpawn()
        {
            GameObject mech = UnityEngine.Object.Instantiate<GameObject>(LexWatchBehaviour.Mech, this.transform.position + new Vector3(2f, 2f), Quaternion.identity);
            mech.SetActive(true);
            mech.transform.localScale = new Vector2((this.transform.localScale.x < 0f)? -1f : 1f, 1f);
            this.MechOut = true;
            ModAPI.CreateParticleEffect("FuseBlown", mech.transform.position);
            yield return new WaitForEndOfFrame();
        }
    }
}
