﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    public class WallStickDetector : MonoBehaviour
    {
        public bool CanStick = true;
        public bool HitSomething = false;
        public bool IsStickable = true;
        public GameObject LastStickedToo;
        public FixedJoint2D LastSticked;
        public GameObject AvoidSticker;
        public float BreakIntensity = Mathf.Infinity;

        public void OnCollisionEnter2D(Collision2D other)
        {
            if (other.gameObject != AvoidSticker)
            {
                if (IsStickable && CanStick)
                {
                    if (LastStickedToo || LastSticked)
                    {
                        LastStickedToo = null;
                        Component.Destroy(LastSticked);
                    }
                    LastSticked = gameObject.AddComponent<FixedJoint2D>();
                    if (other.gameObject.GetComponent<Rigidbody2D>())
                    {
                        LastSticked.connectedBody = other.gameObject.GetComponent<Rigidbody2D>();
                    }
                    LastStickedToo = other.gameObject;
                    LastSticked.breakForce = BreakIntensity;
                }
                HitSomething = true;
            }
        }
    }

    public class DistanceManager : MonoBehaviour
    {
        //This is mainly used for Daredevil's grapple hook, i made it a long time ago so i'm not even sure how it works :D - Camdog74

        public Transform FirstDistance;
        public Transform SecondDistance;
        public bool Reverse = false;
        public DistanceJoint2D joint2D;
        public float Distance = 1;
        public float NewDistance = 1;
        public WallStickDetector CollisionDetector;

        public void Update()
        {
            if (!Reverse && FirstDistance && SecondDistance && joint2D && !CollisionDetector.HitSomething)
            {
                Distance = Vector2.Distance(FirstDistance.position, SecondDistance.position);
                joint2D.distance = Distance + 0.2f;
                joint2D.distance = Mathf.Clamp(joint2D.distance, 0, 25);
            }

            else if (Reverse)
            {
                if (joint2D.distance <= 0.4f)
                {
                    Reverse = false;
                }
                else
                    joint2D.distance = Mathf.Lerp(joint2D.distance, 0.2f, 0.5f * Time.deltaTime);
            }
        }
    }

    public class ShockOnHit : MonoBehaviour
    {
        public void OnCollisionEnter2D(Collision2D other)
        {
            if (other.gameObject.GetComponent<PhysicalBehaviour>())
                other.collider.gameObject.GetComponent<PhysicalBehaviour>().Charge = 1;
        }
    }
}
