﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
using TMPro;
namespace DCPP
{
    public static class Onomatopoeia
    {
        public static void CreateHammerImpact(Vector2 Pos, Vector2 Rot, float Intensity = 1f, bool ImpactSound = true, AudioClip ClipOverride = null)
        {
            GameObject Holder = new GameObject("Poeia", new Type[] 
            { 
                typeof(SpriteRenderer),
                typeof(AudioSource),
                typeof(AudioSourceTimeScaleBehaviour)
            });
            SpriteRenderer Renderer = Holder.GetComponent<SpriteRenderer>();
            Renderer.sortingLayerID = SortingLayer.NameToID("Decals");
            TextMeshPro Text = UnityEngine.Object.Instantiate<TextMeshPro>(ModAPI.FindSpawnable("Thermometer").Prefab.GetComponent<ThermometerBehaviour>().TextMesh);
            Text.sortingLayerID = SortingLayer.NameToID("Decals");
            Text.rectTransform.SetParent(Holder.transform);
            Text.rectTransform.anchoredPosition = Holder.transform.position;
            Text.rectTransform.transform.localPosition = new Vector3(0.45f, 0.1f, 0f);
            Text.color = new Color32(148, 1, 227, 255);
            Text.font = null; //Changes the font to the fallback one I guess
            Text.outlineColor = Color.black;
            Text.outlineWidth = 0.35f;
            Text.transform.localScale = new Vector2(3f, 3f);
            Renderer.sprite = ResourceStorage.Sprite_PoeiaSprite;
            Text.text = "Doink!";
            Text.material.SetFloat(ShaderUtilities.ID_FaceDilate, 1.5f);
            Holder.transform.position = Pos;
            Holder.transform.up = Rot;
            Holder.transform.localScale *= Intensity;
            Text.gameObject.AddComponent<CoroutineRunner>().StartCoroutine(Text.gameObject.GetComponent<CoroutineRunner>().CoolShit(Text));
            Holder.AddComponent<CoroutineRunner>().StartCoroutine(Holder.gameObject.GetComponent<CoroutineRunner>().CoolShit2(Renderer));
            if (ImpactSound)
            {
                Holder.GetComponent<AudioSource>().clip = ResourceStorage.Sound_FunnyComicSound;
                if (ClipOverride)
                {
                    Holder.GetComponent<AudioSource>().clip = ClipOverride;
                }
                Holder.GetComponent<AudioSource>().Play();
            }
        }

        public static void CreateMetalImpact(Vector2 Pos, Vector2 Size, float Intensity = 1f, bool ImpactSound = true, AudioClip ClipOverride = null)
        {

        }

        public static void CreateFistImpact(Vector2 Pos, Vector2 Size, float Intensity = 1f, bool ImpactSound = true, AudioClip ClipOverride = null)
        {

        }

        public class CoroutineRunner : MonoBehaviour
        {
            public IEnumerator CoolShit(TextMeshPro text)
            {
                while (this.gameObject && this.gameObject.activeSelf)
                {
                    text.color = Color.Lerp(text.color, new Color32(148, 1, 227, 0), Time.deltaTime * 5f);
                    if (text.alpha <= 0.02f)
                    {
                        this.gameObject.SetActive(false);
                    }
                    yield return new WaitForEndOfFrame();
                }
                yield return new WaitForEndOfFrame();
            }

            public IEnumerator CoolShit2(SpriteRenderer text)
            {
                while (this.gameObject && this.gameObject.activeSelf)
                {
                    text.color = Color.Lerp(text.color, new Color32(255, 255, 255, 0), Time.deltaTime * 5f);
                    if (text.color.a <= 0.02f)
                    {
                        this.gameObject.SetActive(false);
                    }
                    yield return new WaitForEndOfFrame();
                }
                yield return new WaitForEndOfFrame();
            }
        }
    }
}
