﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    //An empty class for you to copy paste and fill with your own powers!
    public class BaneBoost : PowerBase
    {
        bool BoostMode = false;
        bool Grow = false;
        bool SetValues = false;
        bool BeenBoosted = false;
        bool Removing = false;
        bool MovePosition = true;
        public float BoostTimeAmount = 12;
        public bool IsBane = false;
        public Vector3 OgSize;
        Texture2D OgSkin;
        public List<LimbStats> OgLimbStats = new List<LimbStats>();
        Coroutine BoostTimerCoroutine;

        public void Start()
        {
            //We set our base info and values here
            PowerName = "Bane Boost";
            //We set our power activation type (Head,Chest,Hand)
            Activation = "Head";

            //Always keep this
            base.Start();
            OgSize = GetComponent<LimbBehaviour>().Person.transform.localScale;
        }

        public List<Vector3> OgLimbPos = new List<Vector3>();
        public List<Vector3> OgLimbRot = new List<Vector3>();
        public void Update()
        {
            if (Grow)
            {
                if (GetComponent<LimbBehaviour>().Person.transform.localScale.x < 0)
                {
                    if (!BoostMode && Grow)
                    {
                        GetComponent<LimbBehaviour>().Person.transform.localScale = Vector3.Lerp(GetComponent<LimbBehaviour>().Person.transform.localScale, new Vector3(OgSize.x, OgSize.y, OgSize.z), 15 * Time.deltaTime);
                        GetComponent<LimbBehaviour>().Person.transform.position = Vector3.Lerp(GetComponent<LimbBehaviour>().Person.transform.position, GetComponent<LimbBehaviour>().Person.transform.position - new Vector3(0, 0.2f, 0), 15 * Time.deltaTime);
                    }

                    else if (BoostMode && Grow)
                    {
                        GetComponent<LimbBehaviour>().Person.transform.localScale = Vector3.Lerp(GetComponent<LimbBehaviour>().Person.transform.localScale, GetComponent<LimbBehaviour>().Person.transform.localScale * 1.1f, 15 * Time.deltaTime);
                        GetComponent<LimbBehaviour>().Person.transform.position = Vector3.Lerp(GetComponent<LimbBehaviour>().Person.transform.position, GetComponent<LimbBehaviour>().Person.transform.position - new Vector3(0, -0.2f, 0), 15 * Time.deltaTime);
                    }
                }
                else if (GetComponent<LimbBehaviour>().Person.transform.localScale.x > 0)
                {
                    if (!BoostMode && Grow)
                    {
                        GetComponent<LimbBehaviour>().Person.transform.localScale = Vector3.Lerp(GetComponent<LimbBehaviour>().Person.transform.localScale, OgSize, 15 * Time.deltaTime);
                        if (MovePosition)
                            GetComponent<LimbBehaviour>().Person.transform.position = Vector3.Lerp(GetComponent<LimbBehaviour>().Person.transform.position, GetComponent<LimbBehaviour>().Person.transform.position - new Vector3(0, 0.2f, 0), 15 * Time.deltaTime);
                    }

                    else if (BoostMode && Grow)
                    {
                        GetComponent<LimbBehaviour>().Person.transform.localScale = Vector3.Lerp(GetComponent<LimbBehaviour>().Person.transform.localScale, GetComponent<LimbBehaviour>().Person.transform.localScale * 1.1f, 15 * Time.deltaTime);
                        GetComponent<LimbBehaviour>().Person.transform.position = Vector3.Lerp(GetComponent<LimbBehaviour>().Person.transform.position, GetComponent<LimbBehaviour>().Person.transform.position - new Vector3(0, -0.2f, 0), 15 * Time.deltaTime);
                    }
                }
            }
            else if (Removing && !Grow)
            {
                Component.Destroy(GetComponent<UseEventTrigger>());
                Component.Destroy(this);
            }
        }

        //This is the actual power part of your power, this function will trigger when the activation limb is used.
        public override void UsePower()
        {
            if (!Removing && !Grow && Enabled)
            {
                if (!BoostMode)
                {
                    SetValues = true;
                    foreach (var body in GetComponent<LimbBehaviour>().Person.Limbs)
                    {
                        if (!SetValues)
                        {
                            LimbStats limbBehaviour = new LimbStats();
                            OgLimbStats.Add(limbBehaviour);
                            limbBehaviour.BaseStrength = body.BaseStrength;
                            limbBehaviour.Health = body.Health;
                            limbBehaviour.InitialHealth = body.InitialHealth;
                            limbBehaviour.ShotDamageMultiplier = body.ShotDamageMultiplier;
                            limbBehaviour.Vitality = body.Vitality;
                            limbBehaviour.ImpactPainMultiplier = body.ImpactPainMultiplier;
                            limbBehaviour.Numbness = body.Numbness;
                            limbBehaviour.FakeUprightForce = body.FakeUprightForce;
                            limbBehaviour.BreakingThreshold = body.BreakingThreshold;
                            limbBehaviour.InitialMass = body.PhysicalBehaviour.InitialMass;
                        }

                        //    body.BaseStrength *= 6f;
                        body.Health += 10000f;
                        body.InitialHealth += 10000f;
                        body.ShotDamageMultiplier *= 0f;
                        body.Vitality *= 4.5f;
                        body.ImpactPainMultiplier *= 0.3f;
                        body.Numbness *= 2f;
                        body.FakeUprightForce *= 1.65f;
                        body.BreakingThreshold = 300;
                        //      body.gameObject.GetComponent<RegenerationPower>().CanBeKnockedOut = false; People like him getting knocked out so...
                        //body.GetComponent<PhysicalBehaviour>().InitialMass = body.GetComponent<PhysicalBehaviour>().TrueInitialMass / 8;
                        //body.GetComponent<PhysicalBehaviour>().TrueInitialMass = body.GetComponent<PhysicalBehaviour>().TrueInitialMass / 8;
                        //body.GetComponent<PhysicalBehaviour>().rigidbody.mass = body.GetComponent<PhysicalBehaviour>().TrueInitialMass / 8;
                    }
                    
                    if (IsBane)
                    {
                        OgSkin = GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.sprite.texture;
                        GetComponent<LimbBehaviour>().Person.SetBodyTextures(ResourceStorage.Skin_BaneBoosted);
                    }
                    GetTranforms();
                    GetComponent<LimbBehaviour>().Person.transform.position = transform.position;
                    SetTransformsBack();
                    BoostMode = true;
                    if (!IsBane)
                    {
                        foreach (var item in GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            item.GetComponent<SpriteRenderer>().color = Color.green;
                        }
                    }
                    Grow = true;
                    BeenBoosted = true;
                    StartCoroutine(GrowTimer());
                    BoostTimerCoroutine = StartCoroutine(BoostTimer());
                }
                else if (BoostMode)
                {
                    int indexcount = 0;
                    foreach (var body in GetComponent<LimbBehaviour>().Person.Limbs)
                    {
                        if (OgLimbStats.Count > 0)
                        {
                            body.BaseStrength = OgLimbStats[indexcount].BaseStrength;
                            body.Health = OgLimbStats[indexcount].Health;
                            body.InitialHealth = OgLimbStats[indexcount].InitialHealth;
                            body.ShotDamageMultiplier = OgLimbStats[indexcount].ShotDamageMultiplier;
                            body.Vitality = OgLimbStats[indexcount].Vitality;
                            body.ImpactPainMultiplier = OgLimbStats[indexcount].ImpactPainMultiplier;
                            body.Numbness = OgLimbStats[indexcount].Numbness;
                            body.FakeUprightForce = OgLimbStats[indexcount].FakeUprightForce;
                            body.BreakingThreshold = OgLimbStats[indexcount].BreakingThreshold;
                            //body.GetComponent<PhysicalBehaviour>().InitialMass = OgLimbStats[indexcount].InitialMass;
                            //body.PhysicalBehaviour.rigidbody.mass = OgLimbStats[indexcount].InitialMass;
                            //body.GetComponent<PhysicalBehaviour>().TrueInitialMass = OgLimbStats[indexcount].InitialMass;
                            indexcount += 1;
                        }
                    }

                    if (BeenBoosted && IsBane)
                    {
                        GetComponent<LimbBehaviour>().Person.SetBodyTextures(OgSkin);
                    }
                    BoostMode = false;
                    if (!IsBane)
                    {
                        foreach (var item in GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            item.GetComponent<SpriteRenderer>().color = Color.white;
                        }
                    }
                    Grow = true;
                    GetTranforms();
                    GetComponent<LimbBehaviour>().Person.transform.position = transform.position;
                    SetTransformsBack();
                    StartCoroutine(GrowTimer());
                    StopCoroutine(BoostTimerCoroutine);
                }
            }
        }

        /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected limb of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(LimbBehaviour body, PersonBehaviour person, GameObject Instance, bool IsBane)
        {
            //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
            if (!body.GetComponent<BaneBoost>())
            {
                //Adds your new power to the person NOTE:make sure to change the class to your new power class
                body.gameObject.AddComponent<BaneBoost>().IsBane = IsBane;
                //This sets the power's icon, make sure you add the your new icon to the ResourceStorage NOTE:make sure to change the class to your new power class
                body.GetComponent<BaneBoost>().PowerIcon = ResourceStorage.Sprite_BaneBoosterPowerIcon;

                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    //This triggers your power NOTE:make sure to change the class to your new power class
                    body.gameObject.GetComponent<BaneBoost>().UsePower();
                };
            }
        }

        public override void DisablePower()
        {
            if (BoostMode)
            {
                UsePower();
            }
            base.DisablePower();
        }

        public void GetTranforms()
        {
            int RotPosCount = 0;
            OgLimbPos = new List<Vector3>();
            OgLimbRot = new List<Vector3>();
            foreach (var item in GetComponent<LimbBehaviour>().Person.Limbs)
            {

                OgLimbPos.Add(item.transform.position);
                OgLimbRot.Add(item.transform.eulerAngles);


                RotPosCount += 1;
            }
        }

        public void SetTransformsBack()
        {
            int RotPosCount = 0;
            foreach (var item in GetComponent<LimbBehaviour>().Person.Limbs)
            {
                item.transform.position = OgLimbPos[RotPosCount];
                item.transform.eulerAngles = OgLimbRot[RotPosCount];

                RotPosCount += 1;
            }
        }

        private IEnumerator GrowTimer()
        {
            yield return new WaitForSeconds(0.25f);
            Grow = false;
            //  foreach (var item in GetComponent<LimbBehaviour>().Person.Limbs)
            {
                //  item.PhysicalBehaviour.RecalculateMassBasedOnSize();
            }

        }

        private IEnumerator DisableGrowTimer()
        {
            yield return new WaitForSeconds(0.25f);
            Grow = false;
            //  foreach (var item in GetComponent<LimbBehaviour>().Person.Limbs)
            {
                //  item.PhysicalBehaviour.RecalculateMassBasedOnSize();
            }

        }

        private IEnumerator BoostTimer()
        {
            yield return new WaitForSeconds(BoostTimeAmount);
            UsePower();
            

        }
    }

    public struct LimbStats
    {
        public float BaseStrength;
        public float Health;
        public float InitialHealth;
        public float ShotDamageMultiplier;
        public float Vitality;
        public float ImpactPainMultiplier;
        public float Numbness;
        public float FakeUprightForce;
        public float BreakingThreshold;
        public float InitialMass;
    }
}
