﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    //An empty class for you to copy paste and fill with your own powers!
    public class Flying : PowerBase
    {
        public bool IsFlying = false;
        public List<PhysicalBehaviour> Weightless = new List<PhysicalBehaviour>();
        public ContextMenuButton menuButton;
        public bool Main = false;

        public void Start()
        {
            DisablesGrips = false;
            //We set our base info and values here
            PowerName = "Flying";
            //We set our power activation type (Head,Chest,Hand)
            Activation = "None";

            //Always keep this
            base.Start();
        }

        public void ToggleFlying(bool IsMain = false)
        {
            if (!IsFlying)
            {
                if (IsMain)
                    Main = true;

                GetComponent<LimbBehaviour>().Person.OverridePoseIndex = 8;
                foreach (var item in GetComponent<LimbBehaviour>().Person.GetComponentsInChildren<PhysicalBehaviour>())
                {
                    item.MakeWeightless();
                    Weightless.Add(item);
                    if (item.GetComponent<Flying>())
                    {
                        item.GetComponent<Flying>().IsFlying = true;
                        item.GetComponent<Flying>().Weightless = Weightless;
                    }

                }

                IsFlying = true;
            }
            else if (IsFlying)
            {
                Main = false;
                GetComponent<LimbBehaviour>().Person.OverridePoseIndex = -1;
                foreach (var item in Weightless)
                {
                    item.MakeWeightful();
                    if (item.GetComponent<Flying>())
                    {
                        item.GetComponent<Flying>().IsFlying = false;
                        item.GetComponent<Flying>().Main = false;
                        item.GetComponent<Flying>().Weightless = Weightless;
                    }
                }
                Weightless = new List<PhysicalBehaviour>();
                IsFlying = false;
            }
        }

        /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected limb of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(PersonBehaviour person, GameObject Instance)
        {
            foreach (var body in person.Limbs)
            {
                //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
                if (!body.GetComponent<Flying>())
                {
                    //Adds your new power to the person NOTE:make sure to change the class to your new power class
                    body.gameObject.AddComponent<Flying>();
                    ContextMenuButton menuButton = new ContextMenuButton("togglefly", "Toggle Flying", "Toggle Flying", new UnityAction[1]
{
            (UnityAction) (() =>
        {
            body.gameObject.GetComponent<Flying>().ToggleFlying(true);

                })
});
                    body.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(menuButton);
                    body.gameObject.GetComponent<Flying>().menuButton = menuButton;


                }
            }
        }
    }



}
