﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    public class IvyTouch : PowerBase
    {
        public bool causeDeath = true;

        public void Start()
        {
            DisablesGrips = false;
            //We set our base info and values here
            PowerName = "Posion Kiss";
            //We set our power activation type (Head,Chest,Hand)
            Activation = "Head";

            //Always keep this
            base.Start();
        }

        public override void UsePower()
        {
            causeDeath = !causeDeath;
        }

        public void OnCollisionEnter2D(Collision2D col)
        {
            if (causeDeath)
            {
                if (col.gameObject.TryGetComponent<CirculationBehaviour>(out var circ))
                {
                    circ.AddLiquid(Liquid.GetLiquid("Neurotoxins"), 2.5f);
                }
            }
        }


        /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected limb of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(LimbBehaviour body)
        {
            //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
            if (!body.GetComponent<IvyTouch>())
            {
                //Adds your new power to the person NOTE:make sure to change the class to your new power class
                body.gameObject.AddComponent<IvyTouch>();

                //This sets the power's icon, make sure you add the your new icon to the ResourceStorage NOTE:make sure to change the class to your new power class
                body.GetComponent<IvyTouch>().PowerIcon = ResourceStorage.Sprite_DeathKissPowerIcon;

                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    //This triggers your power NOTE:make sure to change the class to your new power class
                    body.gameObject.GetComponent<IvyTouch>().UsePower();
                };
            }
        }
    }
}
