﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    //An empty class for you to copy paste and fill with your own powers!
    public class LaserEyePower : PowerBase
    {
        /// Team Wilson's Power Pack Framework: Power Template

        public void Awake()
        {
            //We set our base info and values here
            PowerName = "Laser Vision";
            //We set our power activation type (Head,Chest,Hand)
            Activation = "Head";
        }
        
        //This is the actual power part of your power, this function will trigger when the activation limb is used.
        public override void UsePower()
        {
            //This if statement exists to check if your power is selected and enabled in the power menu
            if (Enabled)
            {
                GameObject LaserEyes = Instantiate(ModAPI.FindSpawnable("Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
                ModAPI.CreateParticleEffect("Vapor", transform.position);
                LaserEyes.transform.position = transform.position;
                var Scale = GetComponent<LimbBehaviour>().Person.transform.localScale;
                LaserEyes.transform.eulerAngles = new Vector3(transform.eulerAngles.x, transform.eulerAngles.y, transform.eulerAngles.z + ((Scale.x < 0f)? 180f : 0f));
            }
        }

        /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected limb of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(LimbBehaviour body, PersonBehaviour person, GameObject Instance)
        {
            //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
            if (!body.GetComponent<LaserEyePower>())
            {
                body.gameObject.AddComponent<LaserEyePower>();

                body.GetComponent<LaserEyePower>().PowerIcon = ResourceStorage.Sprite_LaserVisionPowerIcon;

                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    body.gameObject.GetComponent<LaserEyePower>().UsePower();
                };
            }
        }
    }
}
