﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;

namespace DCPP
{
    public class DisablingHands : PowerBase
    {
        private bool On;
        public SpriteRenderer sprite;

        public override void Start()
        {
            PowerName = "Disabling Hands";
            Activation = "Hand";
            base.Start();
        }

        public override void UsePower()
        {
            this.On = !this.On;
            this.sprite.enabled = this.On;
        }

        public void OnCollisionEnter2D(Collision2D col)
        {
            if (col.gameObject.GetComponent<LimbBehaviour>())
            {
                col.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness = 0f;
            }
        }

        public static void SetUpPower(LimbBehaviour body, SpriteRenderer site)
        {
            if (body.GetComponent<DisablingHands>() == null)
            {
                body.gameObject.AddComponent<DisablingHands>().sprite = site;
                body.GetComponent<DisablingHands>().PowerIcon = ResourceStorage.Sprite_PortalPower;
                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    body.gameObject.GetComponent<DisablingHands>().UsePower();
                };
            }
        }
    }
}

