﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    //An empty class for you to copy paste and fill with your own powers!
    public class SlideableHandWeapon : PowerBase
    {
        public void Awake()
        {
            Activation = "Hand";
        }



        bool CanUse = true;
        public GameObject Claw;
        public GameObject body;
        public Vector3 OgGripPos;
        public bool Retracted = true;
        public bool Scale = false;
        int OgSortinglayer;
        int OgSortingOrder;
        public AudioClip SlideInSound;
        public AudioClip SlideOutSound;
        public AudioSource audio;
        public void SetUpClaw(GameObject Body, GameObject claw)
        {
            body = Body;
            Claw = claw;
            Claw.GetComponent<Collider2D>().enabled = false;
            Claw.transform.localPosition = Vector2.zero;
            OgSortingOrder = Claw.GetComponent<SpriteRenderer>().sortingOrder;
            OgSortinglayer = Claw.GetComponent<SpriteRenderer>().sortingLayerID;
            Claw.SetActive(false);
            audio = body.gameObject.AddComponent<AudioSource>();
            audio.spatialBlend = 1;
        }
        public void Update()
        {
            if (Claw)
            {
                if (!Retracted)
                {
                    Claw.transform.localPosition = Vector2.Lerp(Claw.transform.localPosition, new Vector2(0, -0.4f), 25 * Time.deltaTime);
                    if (Scale)
                        Claw.transform.localScale = Vector2.Lerp(Claw.transform.localScale, Vector3.one, 25 * Time.deltaTime);
                }
                else
                {
                    Claw.transform.localPosition = Vector2.Lerp(Claw.transform.localPosition, Vector2.zero, 25 * Time.deltaTime);
                    if (Scale)
                        Claw.transform.localScale = Vector2.Lerp(Claw.transform.localScale, Vector3.zero, 25 * Time.deltaTime);
                }

                if (Claw.GetComponent<PhysicalBehaviour>().penetrations.Count > 0)
                {
                    Claw.GetComponent<SpriteRenderer>().sortingOrder = OgSortingOrder;
                    Claw.GetComponent<SpriteRenderer>().sortingLayerID = OgSortinglayer;
                }
                else
                {
                    Claw.GetComponent<SpriteRenderer>().sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder;
                    Claw.GetComponent<SpriteRenderer>().sortingLayerID = body.GetComponent<SpriteRenderer>().sortingLayerID;
                }
            }


        }

        public void ToggleClaw()
        {
            if (Claw != null && CanUse && Enabled)
            {
                if (Retracted)
                {
                    CanUse = false;
                    Claw.SetActive(true);
                    Retracted = false;
                    foreach (var limbs in body.GetComponent<LimbBehaviour>().Person.Limbs)
                    {
                        if (limbs.GetComponent<SlideableHandWeapon>())
                            Physics2D.IgnoreCollision(limbs.GetComponent<SlideableHandWeapon>().Claw.GetComponent<Collider2D>(), Claw.GetComponent<Collider2D>());
                        Physics2D.IgnoreCollision(limbs.GetComponent<Collider2D>(), Claw.GetComponent<Collider2D>());
                    }
                    Component.Destroy(body.GetComponent<FixedJoint2D>());
                    Claw.transform.position = body.transform.position;
                    Claw.transform.localEulerAngles = Vector3.zero;
                    Claw.transform.eulerAngles = new Vector3(Claw.transform.eulerAngles.x, Claw.transform.eulerAngles.y, Claw.transform.eulerAngles.z + 180);
                    body.gameObject.AddComponent<FixedJoint2D>().connectedBody = Claw.GetComponent<Rigidbody2D>();
                    audio.clip = SlideOutSound;
                    Claw.GetComponent<Collider2D>().enabled = true;
                    Claw.GetComponent<PhysicalBehaviour>().InitialMass = 1;
                    Claw.GetComponent<Rigidbody2D>().velocity = -Claw.transform.up * 5;
                    Claw.GetComponent<Rigidbody2D>().centerOfMass = Vector3.zero;
                    audio.Play();
                    StartCoroutine(ExtendClawTimer());
                }
                else
                {
                    CanUse = false;
                    Retracted = true;
                    Claw.GetComponent<Collider2D>().enabled = false;
                    Claw.GetComponent<PhysicalBehaviour>().InitialMass = 0.001f;
                    Claw.GetComponent<Rigidbody2D>().centerOfMass = new Vector2(0, -0.4f);
                    audio.clip = SlideInSound;
                    audio.Play();
                    StartCoroutine(RetractClawTimer());
                }
            }
        }

        private IEnumerator ExtendClawTimer()
        {
            yield return new WaitForSeconds(0.25f);
            CanUse = true;

        }
        private IEnumerator RetractClawTimer()
        {
            yield return new WaitForSeconds(0.25f);
            Claw.SetActive(false);
            CanUse = true;

        }

        private void OnDisable()
        {
            if (!Retracted)
            {
                CanUse = true;
                ToggleClaw();
            }
           if(this.gameObject.GetComponent<UseEventTrigger>())
            this.gameObject.GetComponent<UseEventTrigger>().enabled = false;
            if (gameObject.GetComponent<GripBehaviour>())
            {
                gameObject.GetComponent<GripBehaviour>().GripPosition = OgGripPos;
            }
            Enabled = false;
        }

        public void EnablePower()
        {
            if (this.gameObject.GetComponent<UseEventTrigger>())
                this.gameObject.GetComponent<UseEventTrigger>().enabled = false;
            if (gameObject.GetComponent<GripBehaviour>())
            {
                gameObject.GetComponent<GripBehaviour>().GripPosition = Vector3.one * 999;
            }
            Enabled = true;
        }

        private void OnRemove()
        {
                StartCoroutine(DestroyTimer());
        }

        public IEnumerator DestroyTimer()
        {
            yield return new WaitForSeconds(0.15f);
            if (body.GetComponent<FixedJoint>())
            {
                Component.Destroy(body.GetComponent<FixedJoint>());
            }
            GameObject.Destroy(Claw);
            if (GetComponent<UseEventTrigger>())
            {
                Component.Destroy(GetComponent<UseEventTrigger>());
            }
            gameObject.GetComponent<GripBehaviour>().GripPosition = OgGripPos;
            Component.Destroy(this);

        }
    }
}
