﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    public class SpeedPower : PowerBase
    {
        private bool SpeedOn;
        public PersonBehaviour Person;
        public TrailRenderer RedTrail1;
        public TrailRenderer YellowTrail;
        public TrailRenderer RedTrail2;
        public Color TrailColor1;
        public Color TrailColor2;

        public override void Start()
        {
            PowerName = "Speedforce";
            Activation = "Head";
            foreach (LimbBehaviour limb in this.Person.Limbs)
            {
                limb.BalanceMuscleMovement *= 2f;
                limb.BaseStrength *= 2f;
            }
            this.RedTrail1 = this.Person.Limbs[1].gameObject.AddComponent<TrailRenderer>();
            this.RedTrail1.emitting = true;
            this.RedTrail1.startColor = TrailColor1;
            this.RedTrail1.endColor = new Color(TrailColor1.r, TrailColor1.g, TrailColor1.b, 0f);
            this.RedTrail1.startWidth = 0.3f;
            this.RedTrail1.endWidth = 0.25f;
            this.RedTrail1.time = 0.25f;
            this.RedTrail1.material = ModAPI.FindMaterial("Sprites-Default");
            this.YellowTrail = this.Person.Limbs[2].gameObject.AddComponent<TrailRenderer>();
            this.YellowTrail.emitting = true;
            this.YellowTrail.startColor = TrailColor2;
            this.YellowTrail.endColor = new Color(TrailColor2.r, TrailColor2.g, TrailColor2.b, 0f);
            this.YellowTrail.startWidth = 0.3f;
            this.YellowTrail.endWidth = 0.25f;
            this.YellowTrail.time = 0.25f;
            this.YellowTrail.material = ModAPI.FindMaterial("Sprites-Default");
            this.RedTrail2 = this.Person.Limbs[3].gameObject.AddComponent<TrailRenderer>();
            this.RedTrail2.emitting = true;
            this.RedTrail2.startColor = TrailColor1;
            this.RedTrail2.endColor = new Color(TrailColor1.r, TrailColor1.g, TrailColor1.b, 0f);
            this.RedTrail2.startWidth = 0.3f;
            this.RedTrail2.endWidth = 0.25f;
            this.RedTrail2.time = 0.25f;
            this.RedTrail2.material = ModAPI.FindMaterial("Sprites-Default");
            this.RedTrail1.enabled = false;
            this.YellowTrail.enabled = false;
            this.RedTrail2.enabled = false;
            //If you use Start while being a subclass of PowerBase, you gotta do Base.Start(); to make the original code work - cam
            //Didn't know that PowerBase had a start function - Aspa
            base.Start();
        }
        
        public override void UsePower()
        {
            if (Enabled)
            {
                SpeedOn = !SpeedOn;
                if (!SpeedOn) //Imagine not writing overengineered code.
                {
                    foreach (KeyValuePair<PoseState, RagdollPose> Pose in Person.LinkedPoses)
                    {
                        Pose.Value.UprightForceMultiplier *= 2f;
                        Pose.Value.Rigidity /= 2f;
                        foreach (KeyValuePair<LimbBehaviour, RagdollPose.LimbPose> angle in Pose.Value.AngleDictionary)
                        {
                            var test = angle.Value;
                            test.AnimationDuration *= 2f;
                            this.StartCoroutine(DoLater(Pose.Value.AngleDictionary, angle.Key, test));
                        }
                    }
                    this.RedTrail1.enabled = false;
                    this.YellowTrail.enabled = false;
                    this.RedTrail2.enabled = false;
                    return;
                }
                this.RedTrail1.enabled = true;
                this.YellowTrail.enabled = true;
                this.RedTrail2.enabled = true;
                foreach (KeyValuePair<PoseState, RagdollPose> Pose in Person.LinkedPoses)
                {
                    Pose.Value.UprightForceMultiplier /= 2f;
                    Pose.Value.Rigidity *= 2f;
                    foreach (KeyValuePair<LimbBehaviour, RagdollPose.LimbPose> angle in Pose.Value.AngleDictionary)
                    {
                        var test = angle.Value;
                        test.AnimationDuration /= 2f;
                        this.StartCoroutine(DoLater(Pose.Value.AngleDictionary, angle.Key, test));
                    }
                }
            }
        }

        private IEnumerator DoLater(Dictionary<LimbBehaviour, RagdollPose.LimbPose> dict, LimbBehaviour limb, RagdollPose.LimbPose pose)
        {
            yield return new WaitForSeconds(0.02f);
            dict[limb] = pose;
        }

        /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected limb of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(LimbBehaviour body, PersonBehaviour person, GameObject Instance)
        {
            //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
            if (!body.GetComponent<SpeedPower>())
            {
                //Adds your new power to the person NOTE:make sure to change the class to your new power class
                body.gameObject.AddComponent<SpeedPower>().Person = person;
                //This sets the power's icon, make sure you add the your new icon to the ResourceStorage NOTE:make sure to change the class to your new power class
                body.GetComponent<SpeedPower>().PowerIcon = ResourceStorage.Sprite_SpeedPowerIcon;

                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    //This triggers your power NOTE:make sure to change the class to your new power class
                    body.gameObject.GetComponent<SpeedPower>().UsePower();
                };
            }
        }
    }
}
