﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    //An empty class for you to copy paste and fill with your own powers!
    public class SpeedsterVibrate : PowerBase,Messages.IUseContinuous
    {
        public bool BeingUsed = false;
        bool CanDamage = true;
        Coroutine UseRoutine;
        Coroutine FlyAnimation;
        GameObject AnimationObject;
        AudioSource auds;
        int wingcount = 0;

        public void Start()
        {
            //We set our base info and values here
            PowerName = "Speedster Vibrate";
            //We set our power activation type (Head,Chest,Hand)
            Activation = "Hand";

            //Always keep this
            base.Start();
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.95f;
            auds.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
            auds.clip = ResourceStorage.Sound_SpeedsterPhaseLoop;
            auds.volume = 1;
            auds.loop = true;
        }

        public void Update()
        {               
                if (BeingUsed)
                {
                    GetComponent<Collider2D>().isTrigger = true;
                  if (!AnimationObject)
                {
                    AnimationObject = new GameObject();
                    AnimationObject.transform.SetParent(transform);
                    AnimationObject.transform.localPosition = Vector3.zero;
                    AnimationObject.transform.localEulerAngles = Vector3.zero;
                    if(gameObject.name == "LowerArmFront")
                    {
                        AnimationObject.AddComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                    }
                    else
                    {
                        AnimationObject.AddComponent<SpriteRenderer>().sortingLayerName = "Background";
                    }
                    AnimationObject.GetComponent<SpriteRenderer>().sortingOrder += 5;
                    AnimationObject.AddComponent<AnimatedObject>().AnimationList = ResourceStorage.VibrateAnimation;
                    AnimationObject.transform.localScale *= 1.2f;
                    auds.PlayOneShot(ResourceStorage.Sound_SpeedsterPhaseStart);
                    auds.Play();
                }
                }
                else if (!BeingUsed)
                {
                    GetComponent<Collider2D>().isTrigger = false;
                    Destroy(AnimationObject);
                auds.Stop();
            }
        }

        public override void UsePower()
        {
            if (!this.BeingUsed)
            {
                this.auds.Stop();
            }
        }

        //This is the actual power part of your power, this function will trigger when the activation limb is used.


        /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected limb of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(LimbBehaviour body, PersonBehaviour person, GameObject Instance)
        {
            //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
            if (!body.GetComponent<SpeedsterVibrate>())
            {
                //Adds your new power to the person NOTE:make sure to change the class to your new power class
                body.gameObject.AddComponent<SpeedsterVibrate>();
                //This sets the power's icon, make sure you add the your new icon to the ResourceStorage NOTE:make sure to change the class to your new power class
                  body.GetComponent<SpeedsterVibrate>().PowerIcon = ResourceStorage.Sprite_SpeedsterPhasePowerIcon;

                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    //This triggers your power NOTE:make sure to change the class to your new power class
                    body.gameObject.GetComponent<SpeedsterVibrate>().UsePower();
                };
            }
        }


        public void OnTriggerStay2D(Collider2D other)
        {
            if (Enabled && BeingUsed && CanDamage)
            {
                if (other.gameObject.GetComponent<LimbBehaviour>())
                    other.gameObject.GetComponent<LimbBehaviour>().Shot(new Shot() { cartridge = ModAPI.FindCartridge("50 AE"), damage = 5, normal = transform.up, point = transform.position, triggersExplosiveOverride = false }) ;
            }
        }

        public virtual IEnumerator VibrateEngageTimer()
        {
            BeingUsed = true;
            yield return new WaitForSeconds(0.02f);

            yield return new WaitForSeconds(0.02f);
            BeingUsed = false;

        }
        
        public virtual IEnumerator VibrateDamageTimer()
        {
            CanDamage = false;
            yield return new WaitForSeconds(0.5f);
            CanDamage = true;

        }


        
        public void UseContinuous(ActivationPropagation activation)
        {
            if (Enabled)
            {
                if (UseRoutine == null)
                    UseRoutine = StartCoroutine(VibrateEngageTimer());
                else
                {
                    StopCoroutine(UseRoutine);
                    UseRoutine = StartCoroutine(VibrateEngageTimer());
                }
            }
        }
    }
}
