﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    //An empty class for you to copy paste and fill with your own powers!
    public class TimeStop : PowerBase
    {
        public bool IsVroom = false;
        public bool CanUse = true;
        public List<PhysicalBehaviour> ObjectsFrozen = new List<PhysicalBehaviour>();
        /// Team Wilson's Power Pack Framework: Power Template

        public void Start()
        {
            //We set our base info and values here
            PowerName = "Time Stop";
            //We set our power activation type (Head,Chest,Hand)
            Activation = "Chest";

            //Always keep this
            base.Start();
        }
        
        //This is the actual power part of your power, this function will trigger when the activation limb is used.
        public override void UsePower()
        {
            if (Enabled)
            {
                if (!IsVroom && !GetComponent<FreezeBehaviour>())
                {
                    bool DoesShow = false;
                    foreach (var item in GameObject.FindObjectsOfType<PhysicalBehaviour>())
                    {
                        if (item.GetComponent<LimbBehaviour>() && !item.gameObject.GetComponent<Undraggable>() && !item.gameObject.GetComponent<MapLightBehaviour>() && !item.gameObject.name.Contains("metro") && !item.gameObject.GetComponent<FreezeBehaviour>() && !GetComponent<LimbBehaviour>().Person.Limbs.Contains(item.GetComponent<LimbBehaviour>()))
                        {
                            item.gameObject.AddComponent<FreezeBehaviour>();
                            ObjectsFrozen.Add(item);
                        }
                        else if (!item.gameObject.GetComponent<FreezeBehaviour>() && !item.gameObject.name.Contains("metro") && !item.gameObject.GetComponent<Undraggable>() && !item.gameObject.GetComponent<MapLightBehaviour>() && !GetComponent<LimbBehaviour>().Person.Limbs.Contains(item.GetComponent<LimbBehaviour>()))
                        {
                            item.gameObject.AddComponent<FreezeBehaviour>();
                            ObjectsFrozen.Add(item);
                        }
                    }
                    IsVroom = true;
                }
                else if (IsVroom && !GetComponent<FreezeBehaviour>())
                {
                    foreach (var item in ObjectsFrozen)
                    {
                        if (item != null)
                            Component.Destroy(item.gameObject.GetComponent<FreezeBehaviour>());
                    }
                    ObjectsFrozen = new List<PhysicalBehaviour>();
                    IsVroom = false;
                }
            }
        }

        /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected limb of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(LimbBehaviour body, PersonBehaviour person, GameObject Instance)
        {
            //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
            if (!body.GetComponent<TimeStop>())
            {
                //Adds your new power to the person NOTE:make sure to change the class to your new power class
                body.gameObject.AddComponent<TimeStop>();
                //This sets the power's icon, make sure you add the your new icon to the ResourceStorage NOTE:make sure to change the class to your new power class
                body.GetComponent<TimeStop>().PowerIcon = ResourceStorage.Sprite_SpeedsterTimeStopPowerIcon;

                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    //This triggers your power NOTE:make sure to change the class to your new power class
                    body.gameObject.GetComponent<TimeStop>().UsePower();
                };
            }
        }

        public void OnDestroy()
        {
            if (ObjectsFrozen.Count > 0)
            {
                foreach (var item in ObjectsFrozen)
                {
                    if (item != null)
                        Component.Destroy(item.gameObject.GetComponent<FreezeBehaviour>());
                }
            }
        }
    }
}
